//
// package at.fhooe.mc.magicwand.client.test;
//
//import at.fhooe.mc.magicwand.client.exceptions.ServerConnectionException;
//import javax.microedition.midlet.*;
//import javax.microedition.lcdui.*;
//import at.fhooe.mc.magicwand.client.network.ClientServerConnection;
//
///**
// * @class NetworkTestMIDlet
// * @briefthis MIDlet can be used to test the socket to the server. a socket connection
// * is established (port 4444) when the MIDlet is started. By clicking on "Send/Receive", you
// * can test if the data transfer is working. The connection can be closed by clicking
// * on "Exit".
// * @author Manu
// */
//public class NetworkTestMIDlet extends MIDlet implements CommandListener {
//
//    /**
//     * pauses the midlet if needed
//     */
//    private boolean m_midletPaused = false;
//    /**
//     * Command to exit the application
//     */
//    private Command m_exitCommand;
//    /**
//     * Command to start send and receive
//     */
//    private Command m_itemCommand;
//    /**
//     * Current used form
//     */
//    private Form m_form;
//    /**
//     * StringItem to write text onto the Form
//     */
//    private StringItem m_stringItem;
//    /**
//     * To use the connection to the server
//     */
//    private ClientServerConnection m_conn;
//
//    /**
//     * @fn public NetworkTestMIDlet()
//     * @brief The HelloMIDlet constructor.
//     */
//    public NetworkTestMIDlet() {
//    }
//
//    /**
//     * @fn private void initialize()
//     * @brief Initilizes the application.
//     * It is called only once when the MIDlet is started. The method is called before the startMIDlet method.
//     */
//    private void initialize() {
//        try {
//            m_conn = new ClientServerConnection(4444);
//
//        } catch (ServerConnectionException _ex) {
//            Alert a = new Alert("Error");
//            a.setString(_ex.getMessage());
//            getDisplay().setCurrent(a, getDisplay().getCurrent());
//        }
//
//
//    }
//
//    /**
//     * @fn public void startMIDlet()
//     * @brief Performs an action assigned to the Mobile Device - MIDlet Started point.
//     */
//    public void startMIDlet() {
//        switchDisplayable(null, getForm());
//
//    }
//
//    /**
//     * @fn public void resumeMIDlet()
//     * @brief Performs an action assigned to the Mobile Device - MIDlet Resumed point.
//     */
//    public void resumeMIDlet() {
//    }
//
//    /**
//     * @fn public void switchDisplayable(Alert _alert, Displayable _nextDisplayable)
//     * @briefSwitches a current _displayable in a display. The display instance is taken from getDisplay method. This method is used by all actions in the design for switching _displayable.
//     * @param _alert the Alert which is temporarily set to the display; if null, then _nextDisplayable is set immediately
//     * @param _nextDisplayable the Displayable to be set
//     */
//    public void switchDisplayable(Alert _alert, Displayable _nextDisplayable) {
//        Display display = getDisplay();
//        if (_alert == null) {
//            display.setCurrent(_nextDisplayable);
//        } else {
//            display.setCurrent(_alert, _nextDisplayable);
//        }
//    }
//
//    /**
//     * @fn public void commandAction(Command _command, Displayable _displayable)
//     * @brief Called by a system to indicated that a _command has been invoked on a particular _displayable.
//     * @param _command the Command that was invoked
//     * @param _displayable the Displayable where the _command was invoked
//     */
//    public void commandAction(Command _command, Displayable _displayable) {
//        if (_displayable == m_form) {
//            if (_command == m_exitCommand) {
//                exitMIDlet();
//            } else if (_command == m_itemCommand) {
//                try {
//                    String result = m_conn.sendAndReceive("MAGIC_WAND_PROTOCOL:11#<xml></xml>");
//                    m_stringItem.setText(result);
//                } catch (ServerConnectionException _ex) {
//                    Alert a = new Alert("Fehler");
//                    a.setString(_ex.getMessage());
//                    getDisplay().setCurrent(a, _displayable);
//                }
//            }
//        }
//    }
//
//    /**
//     * @fn public Command getExitCommand()
//     * @brief Returns an initiliazed instance of m_exitCommand component.
//     * @return the initialized component instance
//     */
//    public Command getExitCommand() {
//        if (m_exitCommand == null) {
//            m_exitCommand = new Command("Exit", Command.EXIT, 0);
//        }
//        return m_exitCommand;
//    }
//
//    /**
//     * @fn public Form getForm()
//     * @brief Returns an initiliazed instance of m_form component.
//     * @return the initialized component instance
//     */
//    public Form getForm() {
//        if (m_form == null) {
//            m_form = new Form("Welcome", new Item[]{getStringItem()});
//            m_form.addCommand(getExitCommand());
//            m_form.addCommand(getItemCommand());
//            m_form.setCommandListener(this);
//        }
//        return m_form;
//    }
//
//    /**
//     * @fn public StringItem getStringItem()
//     * @brief Returns an initiliazed instance of m_stringItem component.
//     * @return the initialized component instance
//     */
//    public StringItem getStringItem() {
//        if (m_stringItem == null) {
//            m_stringItem = new StringItem("TestMidlet", "Testing socket to the server...");
//        }
//        return m_stringItem;
//    }
//
//    /**
//     * @fn public Command getItemCommand()
//     * @brief Returns an initiliazed instance of m_itemCommand component.
//     * @return the initialized component instance
//     */
//    public Command getItemCommand() {
//        if (m_itemCommand == null) {
//            m_itemCommand = new Command("Send/Receive", Command.ITEM, 0);
//        }
//        return m_itemCommand;
//    }
//
//    /**
//     * @fn public Display getDisplay()
//     * @brief Returns a display instance.
//     * @return the display instance.
//     */
//    public Display getDisplay() {
//        return Display.getDisplay(this);
//    }
//
//    /**
//     * @fn public void exitMIDlet()
//     * @brief Exits MIDlet.
//     */
//    public void exitMIDlet() {
//        try {
//            m_conn.closeConnection();
//        } catch (ServerConnectionException _ex) {
//            _ex.printStackTrace();
//        }
//        switchDisplayable(null, null);
//        destroyApp(true);
//        notifyDestroyed();
//    }
//
//    /**
//     * @fn public void startApp()
//     * @brief Called when MIDlet is started.
//     * Checks whether the MIDlet have been already started and initialize/starts or resumes the MIDlet.
//     */
//    public void startApp() {
//        if (m_midletPaused) {
//            resumeMIDlet();
//        } else {
//
//            startMIDlet();
//            initialize();
//        }
//        m_midletPaused = false;
//    }
//
//    /**
//     * @fn public void pauseApp()
//     * @brief Called when MIDlet is paused.
//     */
//    public void pauseApp() {
//        m_midletPaused = true;
//    }
//
//    /**
//     * @fn public void destroyApp(boolean _unconditional)
//     * @brief Called to signal the MIDlet to terminate.
//     * @param _unconditional if true, then the MIDlet has to be unconditionally terminated and all resources has to be released.
//     */
//    public void destroyApp(boolean _unconditional) {
//    }
//}

