/*
 ========================================================================
 Name        : MagicWandServerAppUi.cpp
 Author      : Manuela Vogler
 Copyright   : 
 Description : 
 ========================================================================
 */
// [[[ begin generated region: do not modify [Generated System Includes]
#include <eikmenub.h>
#include <akncontext.h>
#include <akntitle.h>
#include <MagicWandServer.rsg>
// ]]] end generated region [Generated System Includes]

// [[[ begin generated region: do not modify [Generated User Includes]
#include "MagicWandServerAppUi.h"
#include "MagicWandServer.hrh"
#include "MagicWandServerContainerView.h"
// ]]] end generated region [Generated User Includes]
#include "MagicWandServerContainer.hrh"
// [[[ begin generated region: do not modify [Generated Constants]
// ]]] end generated region [Generated Constants]

/**
 * @brief Constructs the CMagicWandServerAppUi instance.
 */
CMagicWandServerAppUi::CMagicWandServerAppUi()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]

	}

/** 
 * @brief The appui's destructor destroys the instance of CCompassServer.
 */
CMagicWandServerAppUi::~CMagicWandServerAppUi()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]
	delete iServer;
	}

// [[[ begin generated function: do not modify
/**
 * @brief Intializes the container view and sets it as default view.
 */
void CMagicWandServerAppUi::InitializeContainersL()
	{
	iMagicWandServerContainerView = CMagicWandServerContainerView::NewL();
	AddViewL(iMagicWandServerContainerView);
	SetDefaultViewL(*iMagicWandServerContainerView);
	}
// ]]] end generated function

/**
 * @brief Handles a command for this appui (override).
 * @param aCommand Command id to be handled
 */
void CMagicWandServerAppUi::HandleCommandL(TInt aCommand)
	{
	// [[[ begin generated region: do not modify [Generated Code]
	TBool commandHandled = EFalse;
	switch (aCommand)
		{ // code to dispatch to the AppUi's menu and CBA commands is generated here
		case EMagicWandServerContainerViewStartMenuItemCommand: //start item clicked
			iServer->SetContainerReference(iMagicWandServerContainerView->GetContainer()); //set container reference
			iServer->StartL(); //start server
			break;
		case EMagicWandServerContainerViewStopMenuItemCommand: //stop item clicked
			iServer->Stop(); //stop server
			break;
		default:
			break;
		}

	if (!commandHandled)
		{
		if (aCommand == EAknSoftkeyExit || aCommand == EEikCmdExit)
			{
			Exit();
			}
		}
	// ]]] end generated region [Generated Code]

	}

/** 
 * @brief Override of the HandleResourceChangeL virtual function.
 */
void CMagicWandServerAppUi::HandleResourceChangeL(TInt aType)
	{
	CAknViewAppUi::HandleResourceChangeL(aType);
	// [[[ begin generated region: do not modify [Generated Code]
	// ]]] end generated region [Generated Code]

	}

/** 
 * @brief Override of the HandleKeyEventL virtual function.
 * @return EKeyWasConsumed if event was handled, EKeyWasNotConsumed if not
 * @param aKeyEvent The key event
 * @param aType Type of event
 */
TKeyResponse CMagicWandServerAppUi::HandleKeyEventL(const TKeyEvent& aKeyEvent,
		TEventCode aType)
	{
	// The inherited HandleKeyEventL is private and cannot be called
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]

	return EKeyWasNotConsumed;
	}

/** 
 * @brief Override of the HandleViewDeactivation virtual function.
 * @param aViewIdToBeDeactivated ID of the view to be deactivated
 * @param aNewlyActivatedViewId ID of the new view to be activated
 */
void CMagicWandServerAppUi::HandleViewDeactivation(
		const TVwsViewId& aViewIdToBeDeactivated,
		const TVwsViewId& aNewlyActivatedViewId)
	{
	CAknViewAppUi::HandleViewDeactivation(aViewIdToBeDeactivated,
			aNewlyActivatedViewId);
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]

	}

/**
 * @brief Completes the second phase of Symbian object construction. 
 * Part of the construction that can leave.
 */
void CMagicWandServerAppUi::ConstructL()
	{
	// [[[ begin generated region: do not modify [Generated Contents]

	BaseConstructL(EAknEnableSkin | EAknEnableMSK);
	InitializeContainersL();
	// ]]] end generated region [Generated Contents]
	iServer = CCompassServer::NewL(); //initialize CompassServer
	}

